/* All rights reserved. Copyright Ron Avitzur - 1992
*/

#define DOT_THRESHHOLD			(Wacom?80:4)
#define PT_SEP_POST 			(Wacom?40:4)
#define PT_SEP_POST_RATIO_X 	8
#define PT_SEP_POST_RATIO_Y 	8

#include "Recognizer.h"

List patterns = NIL;
short Dont_Use_Table = TRUE;
short Wacom;
TABLETRECORD *TRecord;
int dummies[40];
long ScreenYSize,TabYSize,TabYMin,ScreenXSize,TabXSize,TabXMin;
AVList HashList[NUM_HASHLISTS]; /* Assumed all initialized to NIL */
short TRAINING_TIME_OUT = 10,min_weight = 0;
short Training = FALSE;
Rect BBox;
short PauseIsMouse = FALSE;
short RecognizeWords = FALSE;

char **free_list = NIL;
#if 0
char *mycalloc(short n,long size);
char *mycalloc(short n,long size)
	{
	if (free_list == NIL)
		return calloc(n,size);
	else {
		char *ret_val = (char*)free_list;
		free_list = (char**)*free_list;
		return ret_val;
		}		
	}

void myfree(char *p);
void myfree(char *p)
	{
	*(char**)p = (char*)free_list;
	free_list = p;	
	}
#endif

void FreeStrokes() {
	short i;
 	if (Strokes) {
 		for (i = 0; i < Strokes->num_items; i++) {
 			StrokePtr sp = Strokes->items[i];
 			if (sp->matches)
 				free(sp->matches);
 			free(sp);
 			}
 		free(Strokes);
 		}
 	Strokes = NIL;
	}

void DisposePatterns() {
	short i,j,k;
	if (patterns) for (i = 0; i < patterns->num_items; i++) {
		GesturePattern *gp = patterns->items[i];
		if (gp->strokes) for (j = 0; j < gp->strokes->num_items; j++) {
			StrokePattern *sp = gp->strokes->items[j];
			for (k = 0; k < NUM_FEATURES; k++) if (sp->s[k]) free(sp->s[k]);
			free(sp);
			}
		free(gp);
		}
	patterns = NIL;
	}

void Append(List *theList,long item)
	{
	if (*theList == NULL) {
		*theList = malloc(sizeof(List) + sizeof(long));
		(*theList)->num_items = 1;
		(*theList)->items[0] = (void*)item;
		}
	else {
		(*theList)->num_items += 1;
		*theList = realloc(*theList,sizeof(List) + (*theList)->num_items*sizeof(long));
		(*theList)->items[(*theList)->num_items-1] = (void*)item;
		}
	}

void AppendAVPair(AVList *theList,AVPair item)
	{
	if (*theList == NULL) {
		*theList = malloc(sizeof(AVList) + sizeof(AVPair));
		(*theList)->num_items = 1;
		(*theList)->items[0] = item;
		}
	else {
		(*theList)->num_items += 1;
		*theList = realloc(*theList,sizeof(List) + (*theList)->num_items*sizeof(AVPair));
		(*theList)->items[(*theList)->num_items-1] = item;
		}
	}

static int Compare(AVPair *a,AVPair *b);
static int Compare(AVPair *a, AVPair *b)
	{
	if (a->index > b->index) return 1;
	if (a->index < b->index) return -1;
	return 0;
	}

void SearchAndAddMatches(short *possibles,short *weights,short *npossibles,
								AVList theList,register unsigned long n,short w)
	{
	if (theList)
		{
		short where;
		register AVPair *items = theList->items,*guess;
		AVPair key;
		key.index = n;

		guess = bsearch(&key,items,theList->num_items,sizeof(AVPair),(void*)Compare);
		if (guess == NULL) return;
		where = guess - items;
		while (where > 0 && n == items[where-1].index) where--;
		while (where < theList->num_items && n == items[where].index) {
			register short i, code = items[where].code;
			for (i = 0; i < *npossibles; i++) {
				if (possibles[i] == code) {
					weights[i] += w;
					goto NEXT_CODE;
					}
				}
			possibles[*npossibles] = code;
			weights[*npossibles]   = w;
			(*npossibles)++;
			NEXT_CODE:
			where++;
			}
		}
	}

void MakeSearchTables()
	{
	short i,j,k;
	GesturePattern *gp;
	StrokePattern	*sp;
	AVPair item;
	
	for (i=0;i<NUM_HASHLISTS;i++) if (HashList[i]) { free(HashList[i]); HashList[i] = NIL; }
	for (i = 0; i < patterns->num_items; i++) {
		gp = patterns->items[i];
		sp = gp->strokes->items[0];
		for (k=0;k<NUM_HASHLISTS;k++)
			if (sp->s[k]) for (j = 0; j < sp->s[k]->num_items; j++) {
				item.index = (long)sp->s[k]->items[j];
				item.code  = i;
				AppendAVPair(&HashList[k],item);
				}
		}

	/* Sort Tables numerically by index values */
	for (i=0;i<NUM_HASHLISTS;i++) 
		qsort(HashList[i]->items,HashList[i]->num_items,sizeof(AVPair),(void*)Compare);
	Dont_Use_Table = FALSE;
	}

short ATAN2_TABLE[21][21];
short ATAN2(register short dy,register short dx)
	{
	while (dx > 10 || dx < -10 || dy > 10 || dy < -10)
		{ dx >>= 2; dy >>= 2; }
	return ATAN2_TABLE[dy + 10][dx + 10];
	}

void RecognizerInit()
	{
	int Ref;
	long count;
	short i,j;
	double r2d;
	OSErr err;
	err = OpenDriver("\p.Wacom",&Ref);
	Wacom = (err == noErr);
	if (Wacom) err = Status(Ref,GET_RECORD,&TRecord);
	Wacom = (err == noErr);
	if (Wacom) if (TRecord->tabletID != 'TBLT') Wacom = 0;

	r2d = 180 / 3.141592654;
	for (i = 0; i <= 10; i++)
		for (j = 0; j <= 10; j++) {
			short t = r2d * atan2(i,j);
			ATAN2_TABLE[ i + 10][ j + 10] =  t;
			ATAN2_TABLE[-i + 10][ j + 10] = -t;
			ATAN2_TABLE[ i + 10][-j + 10] = 180 - t;
			ATAN2_TABLE[-i + 10][-j + 10] = t - 180;
			}
	SetupMapping();
	}

void SetupMapping()
	{
	if (Wacom) {
		ScreenYSize	= TRecord->screenYMax-TRecord->screenYMin;
		TabYSize		= TRecord->tabYMax-TRecord->tabYMin;
		TabYMin		= TRecord->tabYMin;
		ScreenXSize	= TRecord->screenXMax-TRecord->screenXMin;
		TabXSize		= TRecord->tabXMax-TRecord->tabXMin;
		TabXMin		= TRecord->tabXMin;
		}
	else {
		ScreenYSize	= 1;
		TabYSize		= 1;
		TabYMin		= 0;
		ScreenXSize	= 1;
		TabXSize		= 1;
		TabXMin		= 0;
		}
	}

List Strokes = NIL;
StrokePtr The_Stroke;
char *FastString = "0123456789+-=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
NamedCode Commands[] = {
"\Pdelete",		8,
"\Pspace",		32,
"\P<<--",		r_MOVELEFTINTO,
"\P<-",			r_MOVELEFT,
"\P->",			r_MOVERIGHT,
"\P-->>",		r_MOVERIGHTINTO,
"\Pup",			r_MOVEUP,
"\Pdown",		r_MOVEDOWN,
"\Pisolate",	r_SOLVEFOR,
"\Psimplify",	r_SIMPLIFY,
"\pdot",			DOT_OP,
"\Pvector",		d_VECTOR,
"\pderiv",		o_PARTIAL,
"\Pdiff.",		r_DIFFERENTIATE,
"\p=eval",		r_COPYPASTECRUNCH,
"\ptrig2exp",	r_TRIGTOEXPONENTS,
"\pvec2mat",	r_VECTORSTOMATRICES,
"\ptaylor",		r_TAYLOREXPAND,
"\pmatrix",		r_MATRIXALGEBRA,
"\ppull one",	r_PULLOUTONETERM,
"\pintegrate",	r_INTEGRATE,
"\pintegral",	INTEGRAL_OP
};
short Num_Commands = sizeof(Commands) / sizeof(Commands[0]);

short Learn_Code;
short Current_Pattern = -1;

void Set_Current_Pattern()
	{
	short i;
	Current_Pattern = -1;
	if (patterns)
	for (i = 0; i < patterns->num_items; i++) {
		GesturePattern *gp = patterns->items[i];
		if (gp->code == Learn_Code) {
			Current_Pattern = i;
			return;
			}
		}
	}


short NumSymbols(void)
	{
	return strlen(FastString) + NUM_GREEK + Num_Commands;
	}

short Code(short n)
	{
	short len = strlen(FastString);
	if (n < len)						return FastString[n];
	else if (n < len + NUM_GREEK)	return 0x1300 + n - len;
	else return Commands[n - len - NUM_GREEK].code;
	}

short FindCode(short code)
	{
	short i,len = strlen(FastString);
	for (i = 0; i < len; i++)
		if (code == FastString[i])
			return i;
	for (i = len; i < len + NUM_GREEK; i++)
		if (code == 0x1300 + i - len)
			return i;
	for (i = len + NUM_GREEK; i < NumSymbols(); i++)
		if (code == Commands[i - len - NUM_GREEK].code)
			return i;
	return -1;
	}


void ExtendRange()
	{
	short i,j;
	GesturePattern *gp;
	StrokePattern  *sp;
	StrokePtr		theStroke;
	if (Current_Pattern == -1) { AddNewPattern(); return; }
	if (Strokes == NIL) return;

	gp = patterns->items[Current_Pattern];
	if (gp->strokes->num_items != Strokes->num_items) {
		short code = gp->code;
		for (i = 0; i < patterns->num_items; i++) {
			gp = patterns->items[i];
			if (gp->code == code && gp->strokes->num_items == Strokes->num_items)
				goto GO_ON;
			}
		AddNewPattern();
		return;
		}
GO_ON:
	for (i = 0; i < Strokes->num_items; i++) {
		sp = gp->strokes->items[i];
		theStroke = Strokes->items[i];
		for (j=0;j<NUM_FEATURES;j++)
			if (!IsInList(sp->s[j],theStroke->S[j]))
				Append(&sp->s[j],theStroke->S[j]);
		}
	Dont_Use_Table = TRUE;
	}

void AddNewPattern()
	{
	short i,j;

	GesturePattern *gp;
	StrokePattern  *sp;
	StrokePtr		theStroke;

	if (Strokes == NIL) return;
	gp = malloc(sizeof(GesturePattern));
	if (gp == NIL) {SysBeep(1); Debugger(); ExitToShell();}

	gp->code = Learn_Code;
	gp->strokes = NIL;

	for (i = 0; i < Strokes->num_items; i++) {
		sp = malloc(sizeof(StrokePattern));
		if (sp == NIL) {SysBeep(1); Debugger(); ExitToShell();}
		theStroke = Strokes->items[i];
	
		sp->is_dot = theStroke->IsDot;
		for (j=0;j<NUM_FEATURES;j++) { sp->s[j] = NIL; Append(&sp->s[j],theStroke->S[j]); }
		Append(&gp->strokes,(long)sp);
		}

	Append(&patterns,(long)gp);
	Dont_Use_Table = TRUE;
	}

void ConvertStringToLong(char *s,unsigned long *np,short bits)
	{
	unsigned long n = 0;
	short i,len = strlen(s);
	s[len] = s[len-1];
	if (len > 32/bits) len = 32/bits;
	for (i = 0; i <= len; i++)
		n = (n << bits) + s[len - i] - '0';
	*np = n;
	}

void ConvertLongToString(s,n,bits,name)
 char *s;
 unsigned long n;
 short bits;
 char *name;
	{
	short i = 0, max_len = 32/bits;
	unsigned long mask = (1<<bits)-1;
	if (!name) name = "0123456789abcdef";
	do {
		s[i++] = name[n & mask];
		n = n>>bits;
		}
	while (i < max_len && (i == 1 || s[i - 1] != s[i - 2]));
	if (i != max_len || s[i - 1] == s[i - 2])
			s[i - 1] = 0;
	else	s[i] = 0;
	}


